## yaws 1.96

=== c_src/Makefile ===
include ../include.mk


# don't c-compile anything on win32 (yet)
# I don't know how to make a linked in driver using gcc, or any
# other compiler there, and have no intentions of finding out

ifdef WIN32
	PRIV_FILES=../priv/.foo
else
# don't make pam if configured out with --disable-pam
	PRIV_FILES= ../priv/lib/setuid_drv.$(DLL)  $(EPAM)
endif

ifeq ($(HAVE_YAWS_SENDFILE),true)
	PRIV_FILES += ../priv/lib/yaws_sendfile_drv.$(DLL)
endif


CFLAGS += -I"${ERLDIR}/usr/include"

# and for MacOs + possibly others ...
CFLAGS += -I/usr/include/pam/ $(EXTRAINCLUDE)

#
# Targets
#

all: $(PRIV_FILES)
debug:
	CFLAGS="$(CFLAGS) -g" $(MAKE) all

clean:
	-rm -f $(PRIV_FILES) setuid_drv.$(OBJ) epam.$(OBJ) yaws_sendfile_drv.$(OBJ) hashtable.$(OBJ)

install:	$(PRIV_FILES)
	$(INSTALL) -d $(DESTDIR)$(LIBDIR)/yaws/priv/lib
	$(INSTALL) $(PRIV_FILES) $(DESTDIR)$(LIBDIR)/yaws/priv/lib
ifndef WIN32
	if [ `id -u` = "0" -a -d $(DESTDIR)$(LIBDIR)/yaws/priv/epam ]; then \
		chown root $(DESTDIR)$(LIBDIR)/yaws/priv/epam; \
		chmod a+s $(DESTDIR)$(LIBDIR)/yaws/priv/epam; \
	fi
endif


../priv/lib/setuid_drv.$(DLL): setuid_drv.$(OBJ)
	$(LD_SHARED) $(OUT) $@ $< $(DLL_LIBS)
setuid_drv.$(OBJ):	setuid_drv.c
	$(CC) -c $(FPIC) $(CFLAGS) -DDYNAMIC_DRIVER $<

../priv/lib/yaws_sendfile_drv.$(DLL): yaws_sendfile_drv.$(OBJ) hashtable.$(OBJ)
	$(LD_SHARED) $(OUT) $@ $^ $(DLL_LIBS)
yaws_sendfile_drv.$(OBJ):	yaws_sendfile_drv.c
	$(CC) -c $(FPIC) $(CFLAGS) -DDYNAMIC_DRIVER $<
hashtable.$(OBJ):	hashtable.c
	$(CC) -c $(FPIC) $(CFLAGS) $<

../priv/.foo:
	touch $@

epam.$(OBJ):	epam.c
	$(CC) -c $(CFLAGS) $<
../priv/epam: epam.$(OBJ)
	$(CC) -o $@ $(CFLAGS) $< -lpam

=== src/Makefile ===
include ../include.mk

ifeq ($(TYPE),debug)
DEBUG_FLAGS = -Ddebug +debug_info
else
DEBUG_FLAGS =
endif

include ../vsn.mk
VSN=$(YAWS_VSN)


## the websocket code uses new modern bits stuff
ifeq ($(BITS_SUPPORT),true)
BITSMODS=yaws_websockets
endif


MODULES=yaws \
	yaws_app \
	yaws_ticker \
	yaws_config \
	yaws_server \
	yaws_sup \
	yaws_api \
	yaws_log \
	yaws_trace \
	yaws_logger \
	yaws_ls \
	yaws_debug \
	yaws_compile \
	yaws_ctl \
	yaws_cgi \
	yaws_zlib \
	yaws_generated \
	mime_type_c \
	mime_types \
	yaws_session_server \
	yaws_outmod \
	yaws_revproxy \
	yaws_html  \
	yaws_log_file_h \
	yaws_rss \
	yaws_dav \
	yaws_davlock \
	yaws_pam \
	json json2 jsonrpc yaws_jsonrpc yaws_xmlrpc\
	haxe yaws_rpc \
	yaws_soap_srv yaws_soap_lib yaws_soap12_lib \
	authmod_gssapi \
	yaws_appmod_cgi \
	yaws_appmod_fcgi \
	yaws_sendfile \
	yaws_sup_restarts \
	yaws_stats \
	yaws_vdir \
	yaws_multipart \
	yaws_shaper \
	yaws_dime \
	yaws_exhtml \
	yaws_sse \
	$(BITSMODS)



EBIN_FILES=$(MODULES:%=../ebin/%.$(EMULATOR)) ../ebin/yaws.app ../ebin/yaws.appup
ERLC_FLAGS+=-Werror $(DEBUG_FLAGS) -pa ../../yaws -I ../include

#
# Targets
#
all: yaws_generated.erl yaws_configure.hrl $(EBIN_FILES)

dav:
	$(MAKE) MODULES="$(MODULES) yaws_dav"

$(EBIN_FILES) : ../include/yaws.hrl ../include/yaws_api.hrl

../ebin/yaws_sendfile.$(EMULATOR): yaws_configure.hrl

yaws_generated.erl:	yaws_generated.template ../vsn.mk
	$(MAKE) IS_LOCAL_INSTALL=true gen_yaws_generated

yaws_configure.hrl:	 ../vsn.mk ../include.mk
	if [  $(HAVE_YAWS_SENDFILE) = "true" ]; then \
		echo "-define(HAVE_YAWS_SENDFILE, true)." > yaws_configure.hrl; \
	else touch yaws_configure.hrl; fi

mime_types.erl: ../priv/charset.def ../priv/mime.types \
				../ebin/yaws_generated.$(EMULATOR) ../ebin/mime_type_c.$(EMULATOR)
	$(ERL) -noshell -pa ../ebin -s mime_type_c generate


debug:
	$(MAKE) TYPE=debug

clean:
	rm -f $(EBIN_FILES) yaws_generated.erl yaws_configure.hrl mime_types.erl

install: all docsinstall
	$(MAKE) IS_LOCAL_INSTALL=false gen_yaws_generated
	$(INSTALL) -d $(DESTDIR)$(LIBDIR)/yaws/examples/ebin
	$(INSTALL) -d $(DESTDIR)$(LIBDIR)/yaws/examples/include
	$(INSTALL) -d $(DESTDIR)$(LIBDIR)/yaws/ebin
	$(INSTALL) -d $(DESTDIR)$(LIBDIR)/yaws/priv
	$(INSTALL) -d $(DESTDIR)$(VARDIR)/log/yaws
	$(INSTALL) -d $(DESTDIR)$(VARDIR)/yaws/ebin
	(cd ..; tar cf - ebin ) | (cd $(DESTDIR)$(LIBDIR)/yaws; tar xf - )
	(cd ..; tar cf - include ) | (cd $(DESTDIR)$(LIBDIR)/yaws; tar xf - )
	(cd ..; tar cf - priv/*.xsd ) | (cd $(DESTDIR)$(LIBDIR)/yaws; tar xf - )
	$(INSTALL) -m 644 ../priv/mime.types  $(DESTDIR)$(LIBDIR)/yaws/priv
	$(MAKE) IS_LOCAL_INSTALL=true gen_yaws_generated

docsinstall:
	$(INSTALL) -d $(DESTDIR)$(VARDIR)/yaws/www
	(cd ..; tar cf - www ) | (cd $(DESTDIR)$(VARDIR)/yaws; tar xf - )

tags:
	erl  -noshell -pa ../ebin -s yaws_debug mktags

xref:
	erl -noshell -pa ../ebin -s yaws_debug xref ../ebin



## need to differentiate between local install and not
gen_yaws_generated:
	rm -f yaws_generated.erl ../ebin/yaws_generated.$(EMULATOR)
	YAWS_VSN='$(YAWS_VSN)' VARDIR='$(VARDIR)' ETCDIR='$(ETCDIR)' \
	    ../scripts/gen-yaws-generated $(IS_LOCAL_INSTALL) > yaws_generated.erl
	$(MAKE) ../ebin/yaws_generated.$(EMULATOR)

=== test/Makefile ===
include support/include.mk

SUBDIRS = t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 eunit

all:	ibrowse
	@cd src; $(MAKE) all
	@set -e ; \
          for d in $(SUBDIRS) ; do \
            if [ -f $$d/Makefile ]; then \
              ( cd $$d && $(MAKE) conf && $(MAKE) $@ ) || exit 1 ; \
            fi ; \
          done

clean:
	@cd src; $(MAKE) clean
	rm -rf ibrowse
	@set -e ; \
          for d in $(SUBDIRS) ; do \
            if [ -f $$d/Makefile ]; then \
              ( cd $$d && $(MAKE) $@ ) || exit 1 ; \
            fi ; \
          done

test:
	@set -e ; \
          for d in $(SUBDIRS) ; do \
            if [ -f $$d/Makefile ]; then \
              ( cd $$d && $(MAKE) all start test ) || exit 1 ; \
            fi ; \
          done

ibrowse: fetch_ibrowse
	@cd ibrowse; $(MAKE)

IBROWSE_URI = https://github.com/cmullaparthi/ibrowse.git
IBROWSE_DOWNLOAD_URI = https://github.com/cmullaparthi/ibrowse/tarball/master
IBROWSE_TGZ = ibrowse.tar.gz
IBROWSE_VSN = ibrowse/.version

.PHONY: fetch_ibrowse
fetch_ibrowse:
	nvsn=`git ls-remote -h $(IBROWSE_URI) master 2>/dev/null` ; \
	git_ok=$$? ; \
	set -e ; \
	if [ -f $(IBROWSE_VSN) -a $$git_ok -eq 0 ] ; then \
	  nvsn=`echo $$nvsn | awk '{print $$1}'` ; \
	  vsn=`cat $(IBROWSE_VSN)` ; \
	  [ "$$nvsn" = "$$vsn" ] || fetch=yes ; \
	else \
	  if [ ! -f $(IBROWSE_VSN) -a $$git_ok -ne 0 ] ; then \
	    echo error: ibrowse repository $(IBROWSE_URI) unreachable ; \
	    exit 1 ; \
	  fi ; \
	  [ $$git_ok -eq 0 ] && fetch=yes ; \
	fi ; \
	if [ -n "$$fetch" ] ; then \
	  rm -rf ibrowse ; \
	  curl -L -o $(IBROWSE_TGZ) $(IBROWSE_DOWNLOAD_URI) ; \
	  dir=`tar ztf $(IBROWSE_TGZ) | head -1 | sed -e 's/\/$$//'` ; \
	  tar zxf $(IBROWSE_TGZ) ; \
	  mv $$dir ibrowse ; \
	  rm -f $(IBROWSE_TGZ) ; \
	  echo $$nvsn > $(IBROWSE_VSN) ; \
	fi

=== test/t2/Makefile ===
include ../support/include.mk

.PHONY: all test conf debug clean

#
all:	conf setup app_test.beam streamtest.beam jsontest.beam posttest.beam \
		reentranttest.beam phptest.beam rewritetest.beam shapertest.beam \
		flushtest.beam throwtest.beam dispatchmod_tester.beam cache_appmod_test.beam \
		appmod1.beam appmod2.beam appmod3.beam
	@echo "all ok"


# invoke as
# TEST=test3 make test
# or just make test to run all

ULIMIT = 768

test:	all start
	dd if=/dev/zero of=../../www/1000.txt bs=1024 count=1000 >/dev/null 2>&1
	dd if=/dev/zero of=../../www/2000.txt bs=1024 count=2000 >/dev/null 2>&1
	dd if=/dev/zero of=../../www/3000.txt bs=1024 count=3000 >/dev/null 2>&1
	dd if=/dev/zero of=../../www/10000.txt bs=1024 count=10000 >/dev/null 2>&1
	ul=`ulimit -n` ; \
	val=`expr $$ul '<' $(ULIMIT)` ; \
	if [ $$val = 1 ] ; then \
	    echo trying to raise "ulimit -n" for the test... ; \
	    set -e ; \
	    ulimit -n $(ULIMIT) ; \
	fi ; \
	$(ERL) -noinput $(PA) -s tftest
	$(MAKE) stop

conf:	stdconf

debug:
	$(ERL) $(PA)

clean:	tclean
	-rm -f ../../www/1000.txt ../../www/2000.txt ../../www/3000.txt ../../www/10000.txt
	-rm -f ../../www/test.php
	-rm -rf localhost:8000 logs yaws.conf

=== test/t3/Makefile ===
include ../support/include.mk

.PHONY: all test conf debug clean

#
all:	conf setup app_test.beam authmodtest.beam outmodtest.beam
	@echo "all ok"


# invoke as
# TEST=test3 make test
# or just make test to run all

ULIMIT = 768

test:	all start
	ul=`ulimit -n` ; \
	val=`expr $$ul '<' $(ULIMIT)` ; \
	if [ $$val = 1 ] ; then \
	    echo trying to raise "ulimit -n" for the test... ; \
	    set -e ; \
	    ulimit -n $(ULIMIT) ; \
	fi ; \
	$(ERL) -noinput $(PA) -s tftest
	$(MAKE) stop

conf:	authconf

debug:
	$(ERL) $(PA)

clean:	tclean
	-rm -rf localhost:8000 logs yaws.conf

=== debian/changelog ===
yaws (1.96-3) unstable; urgency=low

  * Fixed FTBFS if built with Erlang R16B01 (closes: #718084).

 -- Sergei Golovan <sgolovan@debian.org>  Sun, 28 Jul 2013 22:33:38 +0400

yaws (1.96-2) unstable; urgency=low

  * Switched to 3.0 (quilt) source package version.
  * Bumped debhelper compatibility version to 8.
  * Bumped standards version to 3.9.4.
  * Separated arch-independent build dependencies from arch-dependent ones.
  * Install yaws_soap_lib.5 manpage.
  * Added a few forgotten objects to clean target.

 -- Sergei Golovan <sgolovan@debian.org>  Fri, 10 May 2013 22:34:36 +0400

yaws (1.96-1) experimental; urgency=low

  * New upstream release.
  * Removed patch which fixed building mime_types.beam because it's no longer
    necessary.

 -- Sergei Golovan <sgolovan@debian.org>  Wed, 20 Mar 2013 13:02:55 +0400

yaws (1.95-1) experimental; urgency=low

  * New upstream feature release.
  * Fixed build of mime_types.beam in case when unversioned yaws link is
    removed from the sources tarball.

 -- Sergei Golovan <sgolovan@debian.org>  Thu, 18 Oct 2012 23:58:09 +0400

yaws (1.94-1) unstable; urgency=low

  * New upstream bugfix release.
  * Removed patches introduced in 1.93-1 and 1.93-2.

 -- Sergei Golovan <sgolovan@debian.org>  Tue, 26 Jun 2012 10:08:55 +0400

yaws (1.93-2) unstable; urgency=low

  * Added a patch which fixes delivering directory listings.

 -- Sergei Golovan <sgolovan@debian.org>  Tue, 26 Jun 2012 09:17:49 +0400

yaws (1.93-1) unstable; urgency=low

  * New upstream release.
  * Refreshed patches and removed those which are no longer necessary.
  * Added a patch which strengthens the random number generation for the
    chat and mail applications. It also ensures all the characters in
    the yaws_session_server cookies are printable.
  * Don't compress the yaws.eps logo in the examples.
  * Removed use_fdsrv option from the yaws.conf because its support is
    removed by upstream.

 -- Sergei Golovan <sgolovan@debian.org>  Sun, 24 Jun 2012 15:45:00 +0400

yaws (1.92-4) unstable; urgency=low

  * Removed unnecessary suggested dependency on erlang-dev.
  * Cleaned up debian/rules a bit.
  * Bumped debhelper competibility version to 7 because of dh_lintian.
  * Bumped standards version to 3.9.3.

 -- Sergei Golovan <sgolovan@debian.org>  Fri, 08 Jun 2012 09:20:57 +0400

yaws (1.92-3) unstable; urgency=low

  * Switched to long options in init.d script because the short ones aren't
    documented anymore.
  * Added a short notice on how to bind to a privileged port in yaws.default
    file comments and README.Debian.
  * Change Yaws config files permissions only if the local admin didn't
    override them using dpkg-statoverride.
  * Switched to the snakeoil SSL certificate from generating a new one in
    postinstallation script.

 -- Sergei Golovan <sgolovan@debian.org>  Mon, 14 May 2012 16:57:06 +0400

yaws (1.92-2) unstable; urgency=low

  * Added patch which fixes version and modules list in the yapp application
    script yapp.app.

 -- Sergei Golovan <sgolovan@debian.org>  Wed, 22 Feb 2012 10:40:29 +0400

yaws (1.92-1) unstable; urgency=low

  * New upstream release.
  * Removed patches which fix directory traversal bug and loading external
    drivers for Erlang R15B because they are included into this upstream
    release.
  * Added a few more fixes for compatibility with Erlang R15B.
  * Removed patch which uses external mime.types.
  * Added a patch which fixes CVE-2011-5025 in the yaws-wiki package
    (closes: #653966).
  * Copied acceptor_pool_size option to yaws.conf from the upstream config.

 -- Sergei Golovan <sgolovan@debian.org>  Wed, 18 Jan 2012 09:46:18 +0400

yaws (1.91-3) experimental; urgency=low

  * Added patch which fixes loading external drivers in Erlang R15B.
  * Added patch which moves from regexp to re module because the former
    is removed from Erlang R15B.

 -- Sergei Golovan <sgolovan@debian.org>  Sat, 17 Dec 2011 12:30:44 +0400

yaws (1.91-2) unstable; urgency=high

  * Added patch by Uwe Dauernheim which fixes directory traversal bug
    (closes: #650009).

 -- Sergei Golovan <sgolovan@debian.org>  Sat, 26 Nov 2011 19:34:12 +0400

yaws (1.91-1) unstable; urgency=low

  * New upstream release.

 -- Sergei Golovan <sgolovan@debian.org>  Tue, 09 Aug 2011 23:26:01 +0400

yaws (1.90-2) unstable; urgency=low

  * Removed -m32 and -m64 gcc command line option which led to FTBFS on
    ia64 and s390 architectures.

 -- Sergei Golovan <sgolovan@debian.org>  Mon, 13 Jun 2011 16:34:40 +0400

yaws (1.90-1) unstable; urgency=low

  * New upstream release.
  * Bumped standards version to 3.9.2.
  * Fixed a few spelling errors in package descriptions.
  * Fixed a bug in yaws.conf(5) manpage.

 -- Sergei Golovan <sgolovan@debian.org>  Mon, 13 Jun 2011 15:34:55 +0400

yaws (1.89-1) experimental; urgency=low

  * New upstream release.
  * Synchrinized config file with the upstream version.
  * Bumped standards version to 3.9.1.

 -- Sergei Golovan <sgolovan@debian.org>  Fri, 19 Nov 2010 09:19:07 +0300

yaws (1.88-2) unstable; urgency=low

  * Split out Yaws application to a separate package erlang-yaws, which
    simplifies using Yaws in embedded mode. The yaws binary package now
    includes additional binaries and configs necessary to run a standalone
    Yaws daemon.
  * Bumped standards version to 3.9.0.

 -- Sergei Golovan <sgolovan@debian.org>  Fri, 23 Jul 2010 17:38:18 +0400

yaws (1.88-1) unstable; urgency=low

  * New upstream release.
  * Bumped standards version to 3.8.4.

 -- Sergei Golovan <sgolovan@debian.org>  Wed, 24 Mar 2010 15:43:06 +0300

yaws (1.87-1) unstable; urgency=low

  * New upstream release.
  * Moved Yaws binaries to /usr/lib/yaws directory to follow upstream closer
    and to make sure that private Yaws modules don't clash with any other
    application. The drawback is that now one has to add -pa /usr/lib/yaws/ebin
    to the command line if he wants to use Yaws in embedded mode.


=== debian/control ===
Source: yaws
Section: httpd
Priority: optional
Maintainer: Debian Erlang Packagers <pkg-erlang-devel@lists.alioth.debian.org>
Uploaders: Sergei Golovan <sgolovan@debian.org>
Build-Depends: debhelper (>= 8.9.7), autotools-dev, libpam0g-dev,
 erlang-dev (>= 1:13.b.1-3), erlang-edoc, erlang-mnesia
Build-Depends-Indep: texlive-latex-base, texlive-latex-recommended,
 texlive-fonts-recommended, texlive-font-utils, texlive-extra-utils, ghostscript
Standards-Version: 3.9.4
Homepage: http://yaws.hyber.org/
Vcs-Svn: svn://svn.debian.org//svn/pkg-erlang/yaws/trunk/
Vcs-Browser: http://svn.debian.org/wsvn/pkg-erlang/yaws/trunk/

Package: yaws
Architecture: all
Provides: httpd, httpd-cgi
Depends: erlang-yaws (>= ${binary:Version}), adduser, ssl-cert, ${misc:Depends}
Suggests: yaws-doc, yaws-chat, yaws-mail, yaws-wiki, yaws-yapp
Description: High performance HTTP 1.1 webserver written in Erlang
 Yaws is a high performance HTTP 1.1 webserver written in Erlang. It is a 
 multithreaded webserver where one Erlang light weight process is used to
 handle each client. Two separate modes of operation are supported.
 .
 This package includes binaries and config to run Yaws in standalone mode
 where it works as a regular webserver daemon.

Package: erlang-yaws
Architecture: any
Depends: ${erlang-abi:Depends}, ${erlang:Depends}, ${shlibs:Depends}, ${misc:Depends}
Suggests: yaws, yaws-doc, zip, bzip2
Replaces: yaws (<< 1.88-2)
Description: Erlang application which implements HTTP webserver
 Yaws is a high performance HTTP 1.1 webserver written in Erlang. It is a 
 multithreaded webserver where one Erlang light weight process is used to
 handle each client. Two separate modes of operation are supported.
 .
 This package includes Erlang Yaws application suitable to work in embedded
 mode where it runs as a webserver in another Erlang application.

Package: yaws-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: erlang-yaws, yaws
Replaces: yaws (<< 1.87)
Description: Documentation and examples for Yaws web server
 Yaws is a high performance HTTP 1.1 webserver written in Erlang. It is a 
 multithreaded webserver where one Erlang light weight process is used to
 handle each client.
 .
 This package includes Yaws documentation and examples.

Package: yaws-chat
Section: web
Architecture: all
Depends: ${erlang:Depends}, yaws (>= ${binary:Version}), ${misc:Depends}
Description: Chat application for Yaws web server
 Yaws-chat allows one to create a very simple web-based chatroom.

Package: yaws-mail
Section: web
Architecture: all
Depends: ${erlang:Depends}, yaws (>= ${binary:Version}), ${misc:Depends}
Description: Webmail application for Yaws web server
 Yaws-mail is a small stateless webmail application. It requires
 SMTP and POP3 servers to operate and does not store email locally.

Package: yaws-wiki
Section: web
Architecture: all
Depends: ${erlang:Depends}, yaws (>= ${binary:Version}), ${misc:Depends}
Description: Wiki application for Yaws web server
 Yaws-wiki is a small wiki application, written in Erlang for Yaws
 web server.

Package: yaws-yapp
Section: web
Architecture: all
Depends: ${erlang:Depends}, yaws (>= ${binary:Version}), ${misc:Depends}
Description: Provides an easy way to deploy applications for Yaws web server
 Yaws-yapp (Yaws application handler) is a helper application.
 It takes care of adding, and removing, the applications into a running
 server. When anyone access the server with an URL that matches the path
 for an added application, the docroot will be temporarily switched
 to where the web pages for that application are located.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

export HOME := $(CURDIR)/debian

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

DESTDIR=$(CURDIR)/debian/yaws
DESTDIR1=$(CURDIR)/debian/erlang-yaws
TMPDIR=$(CURDIR)/debian/tmp

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	TYPE = debug
endif

%:
	dh $@

override_dh_clean:
	dh_testdir
	dh_testroot
	#
	# Clean up applications included into yaws distribution
	[ ! -f include.mk ] || \
	for appdir in applications/* ; do \
	    (cd $$appdir ; \
	     $(MAKE) clean || exit 1 ; \
	     $(MAKE) cleandocs || exit 1) \
	done
	rm -rf applications/chat/ebin
	#
	# Clean up after the build process.
	[ ! -f include.mk ] || $(MAKE) clean
	[ ! -f include.mk ] || $(MAKE) conf_clean
	rm -f priv/charset.def
	#
	rm -f erl_crash.dump
	rm -f debian/yaws-*.postinst debian/yaws-*.postrm
	#
	dh_clean

override_dh_auto_configure:
	dh_testdir
	#
	CFLAGS="$(CFLAGS)" \
	./configure --host=$(DEB_HOST_GNU_TYPE) \
		    --build=$(DEB_BUILD_GNU_TYPE) \
		    --prefix=/usr \
		    --mandir=/usr/share/man \
		    --infodir=/usr/share/info \
		    --sysconfdir=/etc \
		    --localstatedir=/var

override_dh_auto_build-arch:
	dh_testdir
	#
	# Compile the package.
	mkdir -p examples/ebin
	TYPE="$(TYPE)" $(MAKE) DLL_LIBS=-lc

override_dh_auto_build-indep:
	dh_testdir
	#
	# Build applications included into yaws distribution
	for appdir in applications/* ; do \
	    (cd $$appdir ; \
	     mkdir -p ebin ; \
	     TYPE="$(TYPE)" $(MAKE) || exit 1) \
	done
	#
	# Build documentation
	$(MAKE) docs

override_dh_auto_test:
	# Do nothing because the tests require downloading some tools from
	# the Internet.

override_dh_auto_install-arch:
	dh_testdir
	#
	# Install the package into debian/yaws.
	$(MAKE) install DESTDIR=$(TMPDIR)
	#
	# Fix location of epam binary
	mv $(TMPDIR)/usr/lib/yaws/priv/lib/epam $(TMPDIR)/usr/lib/yaws/priv/
	#
	# Fix permissions on examples
	chmod a-x $(TMPDIR)/var/yaws/www/testdir/index.html
	#
	# Remove duplicated headers
	rm -f $(TMPDIR)/usr/lib/yaws/*.hrl
	#
	# Remove useless .empty files and .xvpics directory
	find $(TMPDIR) -type f -name '.*' -print -exec rm -rf \{\} \;
	#
	# Remove empty directories
	rm -rf $(TMPDIR)/usr/lib/yaws/examples/
	#
	dh_install -a

override_dh_auto_install-indep:
	dh_testdir
	#
	# Install applications (and READMEs) included into yaws distribution
	# Application beams go to /usr/lib/yaws/$application/ebin
	# Other application files go to /usr/share/yaws-$application/docroot
	for appdir in applications/* ; do \
	    (cd $$appdir ; \
	     app=`basename $$appdir` ; \
	     $(MAKE) install DESTDIR=$(DESTDIR)-$$app \
	     		     EBININSTALLDIR=$(DESTDIR)-$$app/usr/lib/yaws/$$app/ebin \
	     		     CHATINSTALLDIR=$(DESTDIR)-chat/usr/share/yaws-chat \
	     		     MAILINSTALLDIR=$(DESTDIR)-mail/usr/share/yaws-mail \
	     		     WIKIINSTALLDIR=$(DESTDIR)-wiki/var/lib/yaws-wiki || exit 1) \
	done
	#
	# Fix permissions of application files
	for appdir in applications/* ; do \
	    app=`basename $$appdir` ; \
	    find $(DESTDIR)-$$app -type f -exec chmod a-x \{\} \; ; \
	done
	#
	# Remove useless empty files
	for appdir in applications/* ; do \
	    app=`basename $$appdir` ; \
	    find $(DESTDIR)-$$app -type f -name '.*' -print -exec rm -f \{\} \; ; \
	done
	#
	# Generate postinst and postrm scripts for applications
	for appdir in applications/* ; do \
	    app=`basename $$appdir` ; \
	    sed -e "s/@APPLICATION@/$$app/g" \
	    	debian/yaws-application.postinst.in >debian/yaws-$$app.postinst || exit 1; \
	    sed -e "s/@APPLICATION@/$$app/g" \
	    	debian/yaws-application.postrm.in >debian/yaws-$$app.postrm || exit 1 ; \
	done
	#
	dh_install -i

override_dh_compress:
	dh_compress -X.erl -X.beam -X.yaws -X.pdf -X .ps -X .eps

override_dh_gencontrol:
	erlang-depends
	dh_gencontrol

v=1.96

get-orig-source:
	wget -O - http://yaws.hyber.org/download/yaws-$(v).tar.gz | tar zx
	tar zcf yaws_$(v).orig.tar.gz yaws-$(v)
	rm -r yaws-$(v)
	rm yaws

.PHONY: override_dh_clean override_dh_auto_configure override_dh_auto_build-arch override_dh_auto_build-indep \
	override_dh_auto_test override_dh_auto_install-arch override_dh_auto_install-indep \
	override_dh_compress override_dh_gencontrol get-orig-source

## yaws 1.98

=== Makefile ===

SUBDIRS	=	c_src src man www/shoppingcart www/code doc scripts \
                examples/src
include ./include.mk
include ./vsn.mk

PKGCONFIG_FILES = yaws.pc

all debug clean:
	@set -e ; \
	  for d in $(SUBDIRS) ; do \
	    if [ -f $$d/Makefile ]; \
		then ( cd $$d && $(MAKE) $@ ) || exit 1 ; \
	    fi ; \
	  done
	rm -rf yaws-${YAWS_VSN}.script yaws-${YAWS_VSN}.boot
	rm -rf yaws-${YAWS_VSN}.rel yaws-${YAWS_VSN}.tar.gz

cleantests:
	cd test && $(MAKE) clean

clean: cleantests

install:	all
	set -e ; \
	for d in $(SUBDIRS) ; do \
	    if [ -f $$d/Makefile ]; \
		then ( cd $$d && $(MAKE) $@ ) || exit 1 ; \
	    fi ; \
	done
	$(INSTALL) -d $(DESTDIR)$(LIBDIR)/pkgconfig
	$(INSTALL) -m 644 $(PKGCONFIG_FILES) $(DESTDIR)$(LIBDIR)/pkgconfig
	@echo "-------------------------------"
	@echo
	@echo "** etc files went into        ${ETCDIR}"
	@echo "** executables went into      ${prefix}/bin"
	@echo "** library files went into    ${LIBDIR}/yaws"
	@echo "** var files went into        ${VARDIR}"
	@echo "** default docroot went into  ${VARDIR}/yaws/www"
	@echo
	@echo "--------------------------------"


docs:
	( cd doc && $(MAKE) docs )

conf_clean:
	-rm include.mk config.cache config.status config.log yaws.pc \
	test/support/include.mk test/support/include.sh 2> /dev/null

local_install: all
	(cd scripts && $(MAKE) local_install)


# Target for folks that want to build a proper OTP release
# to be used with regular OTP release management.
release:	vsn.mk include.mk yaws.rel.src all
	sed -e "s/%YAWS_VSN%/${YAWS_VSN}/g" \
	       -e "s/%ERTS_VSN%/${ERTS_VSN}/" \
	       -e "s/%KERNEL_VSN%/${KERNEL_VSN}/" \
	       -e "s/%STDLIB_VSN%/${STDLIB_VSN}/" \
	       -e "s/%SASL_VSN%/${SASL_VSN}/" \
	       -e "s/%MNESIA_VSN%/${MNESIA_VSN}/" \
	< yaws.rel.src > yaws-${YAWS_VSN}.rel
	erlc -pa ./ebin yaws-${YAWS_VSN}.rel
	erl -pa ./ebin -noinput -run systools make_tar yaws-${YAWS_VSN} \
	       -s erlang halt
	@echo "-------------------------------"
	@echo
	@echo "Best to rerun this in an Erlang shell to pick up include directory:"
	@echo
	@echo "$$ erl -pa ./ebin"
	@echo "1> systools:make_tar(\"yaws-${YAWS_VSN}\", [{dirs,[include,examples,src]}])."
	@echo
	@echo "--------------------------------"

touch:
	find . -name '*' -print | xargs touch -m
	find . -name '*.erl' -print | xargs touch -m

yaws.plt:
	dialyzer --build_plt -r ebin --output_plt yaws.plt \
	   -r $(ERLDIR)/lib/sasl-$(SASL_VSN) \
	   -r $(ERLDIR)/lib/kernel-$(KERNEL_VSN) \
	   -r $(ERLDIR)/lib/stdlib-$(STDLIB_VSN) \
	   -r $(ERLDIR)/lib/erts-$(ERTS_VSN)

# Not debug compiled, let's just ignore it
#   	   -r $(ERLDIR)/lib/ssl-$(SSL_VSN)

dialyzer:	yaws.plt
	-dialyzer -q --plt yaws.plt -r ebin > dialyzer_warnings
	diff -U0 known_dialyzer_warnings dialyzer_warnings

.PHONY: test
test: all
	cd test && $(MAKE) all setup test

=== c_src/Makefile ===
--- 
+++ 
@@ -12,7 +12,7 @@
 	PRIV_FILES= ../priv/lib/setuid_drv.$(DLL)  $(EPAM)
 endif
 
-ifeq ($(HAVE_YAWS_SENDFILE),true)
+ifeq ($(HAVE_SENDFILE),true)
 	PRIV_FILES += ../priv/lib/yaws_sendfile_drv.$(DLL)
 endif

=== doc/Makefile ===

include ../include.mk
include ../vsn.mk

IMG_EPS = $(wildcard *.eps)
IMG_PDF = $(IMG_EPS:.eps=.pdf)

all debug:
	echo "To build the docs, please use make docs before doing make install"

docs:	check yaws.ps yaws.pdf

check:
	@if [ -z "$(DVIPS)" ]; then \
		echo "Need dvips"; exit 1; \
	fi
	@if [ -z "$(PDFLATEX)" ]; then \
		echo "Need pdflatex"; exit 1; \
	fi
	@if [ -z "`which latex2html`" ]; then \
		echo "Need latex2html"; exit 1; \
	fi



yaws.ps:	yaws.dvi
	$(COND_DVILATEX)$(DVIPS) -o yaws.ps yaws.dvi
	$(COND_DVILATEX)cp yaws.ps ../www

yaws.pdf:	yaws.tex $(IMG_PDF)
	$(COND_PDFLATEX)$(PDFLATEX) yaws.tex
	$(COND_PDFLATEX)$(PDFLATEX) yaws.tex
	$(COND_PDFLATEX)cp yaws.pdf ../www

yaws.dvi:	yaws.tex  $(IMG_EPS)
	$(COND_DVILATEX)$(DVILATEX) yaws.tex
	$(COND_DVILATEX)$(DVILATEX) yaws.tex

%.pdf:	%.eps
	$(COND_PDFLATEX)$(EPSTOPDF) $<

clean:
	rm  -f *.ps *.dvi *.log *.aux *.pdf *.toc *.beam 2> /dev/null || true
	rm  -f *.out ../www/yaws.ps ../www/yaws.pdf 2> /dev/null || true

install:
	-install -d $(DESTDIR)$(PREFIX)/share/doc/yaws
	-cp yaws.pdf $(DESTDIR)$(PREFIX)/share/doc/yaws

=== man/Makefile ===

include ../include.mk

install:
	install -d $(DESTDIR)$(PREFIX)/share/man/man1
	install -d $(DESTDIR)$(PREFIX)/share/man/man5
	cp yaws.1 $(DESTDIR)$(PREFIX)/share/man/man1
	cp yaws.conf.5 $(DESTDIR)$(PREFIX)/share/man/man5
	cp yaws_api.5 $(DESTDIR)$(PREFIX)/share/man/man5



## for the win32 build, the rest of us know how to run man
pdf:
	man -t ./yaws.1 > xxx;  ps2pdf xxx yaws.1.pdf
	man -t ./yaws.conf.5 > xxx; ps2pdf xxx yaws.conf.5.pdf
	man -t ./yaws_api.5 > xxx; ps2pdf xxx yaws_api.5.pdf
	man -t ./yaws_soap_lib.5 > xxx; ps2pdf xxx yaws_soap_lib.5.pdf
	rm xxx;

clean:
	rm *.pdf 2>/dev/null || true


all debug:

=== scripts/Makefile ===
include ../include.mk


all debug:	../bin/yaws yaws.conf

../bin/yaws:	yaws.template
	VARDIR='$(VARDIR)' ERLBINDIR='$(ERLBINDIR)' \
	ERL='$(ERL)' WERL='$(WERL)' ./gen-yaws > $@
	chmod +x $@


local_install:	../bin/yaws
	VARDIR="${HOME}/var" ./local-install true

yaws.conf:
	YAWSDIR='$(LIBDIR)/yaws' LOGDIR='$(PREFIX)/var/log/yaws' \
	VARDIR='$(VARDIR)' PORT=80 DOCROOT='$(VARDIR)/yaws/www' \
	CERTDIR='$(ETCDIR)/yaws' SSLPORT=443 ./gen-yaws-conf > $@

clean:
	rm -f ../bin/yaws yaws.conf

install:	.install

.install:
	PREFIX='$(PREFIX)' ETCDIR='$(ETCDIR)' VARDIR='$(VARDIR)' \
	ERLBINDIR='$(ERLBINDIR)' DESTDIR='$(DESTDIR)' LIBDIR='$(LIBDIR)' \
	ERL='$(subst ",,$(ERL))' WERL='$(subst ",,$(WERL))' ./regular-install

=== src/Makefile ===
--- 
+++ 
@@ -41,13 +41,12 @@
 	yaws_html  \
 	yaws_log_file_h \
 	yaws_rss \
-	yaws_dav \
-	yaws_davlock \
+	yaws_appmod_dav \
+	yaws_runmod_lock \
 	yaws_pam \
 	json json2 jsonrpc yaws_jsonrpc yaws_xmlrpc\
 	haxe yaws_rpc \
 	yaws_soap_srv yaws_soap_lib yaws_soap12_lib \
-	authmod_gssapi \
 	yaws_appmod_cgi \
 	yaws_appmod_fcgi \
 	yaws_sendfile \
@@ -72,7 +71,7 @@
 all: yaws_generated.erl yaws_configure.hrl $(EBIN_FILES)
 
 dav:
-	$(MAKE) MODULES="$(MODULES) yaws_dav"
+	$(MAKE) MODULES="$(MODULES) yaws_appmod_dav yaws_runmod_lock"
 
 $(EBIN_FILES) : ../include/yaws.hrl ../include/yaws_api.hrl
 
@@ -82,9 +81,11 @@
 	$(MAKE) IS_LOCAL_INSTALL=true gen_yaws_generated
 
 yaws_configure.hrl:	 ../vsn.mk ../include.mk
-	if [  $(HAVE_YAWS_SENDFILE) = "true" ]; then \
-		echo "-define(HAVE_YAWS_SENDFILE, true)." > yaws_configure.hrl; \
-	else touch yaws_configure.hrl; fi
+	rm -f $@
+	[ $(HAVE_SENDFILE) = true ] && echo '-define(HAVE_SENDFILE, true).' > $@; \
+	[ $(HAVE_ERLANG_SENDFILE) = true ] && echo '-define(HAVE_ERLANG_SENDFILE, true).' >> $@; \
+	[ $(HAVE_CRYPTO_HASH) = true ] && echo '-define(HAVE_CRYPTO_HASH, true).' >> $@; \
+	[ -f $@ ] || touch $@
 
 mime_types.erl: ../priv/charset.def ../priv/mime.types \
 				../ebin/yaws_generated.$(EMULATOR) ../ebin/mime_type_c.$(EMULATOR)

=== test/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 include support/include.mk
 
-SUBDIRS = t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 eunit
+SUBDIRS = t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 eunit
 
 all:	ibrowse
 	@cd src; $(MAKE) all

=== win32/Makefile ===
##
## Debian Linux mingw cross-compiler version:
## To install
# sudo apt-get install mingw32

TARGET  = i586-mingw32msvc-

CC	= $(TARGET)gcc
AR	= $(TARGET)ar
LD	= $(TARGET)gcc


CP	= cp
RM	= rm -f
MKDIR	= -mkdir

##
## Definitions:
##
CFLAGS = -O2 -Wall
INCLUDES = -I.


##
## Global Makefile settings
##
OBJS = \
	yaws.o

.c.o:
	$(CC) -c $(CFLAGS) $(INCLUDES) -o $@ $<

##
## Targets
##
all:	yaws.exe
	./mkinstaller.sh


yaws.exe:	$(OBJS)
	$(CC) $(CFLAGS) $(OBJS) -o yaws.exe


clean:
	$(RM) *.o
	$(RM) *.a
	$(RM) *.exe
	$(RM) -rf ebin examples applications ssl src www include doc priv bin logs scripts vsn.mk  LICENSE.txt build.xml

=== www/Makefile ===

YAWS := $(wildcard *.yaws)
CHECK := $(YAWS:%.yaws=%.check)

all:	$(CHECK)

clean:
	rm *.check

%.check:	%.yaws
	../../bin/yaws --check $< ../include && touch $@

=== applications/chat/Makefile ===
SUBDIRS	= src
include ./include.mk


all debug clean install:
	@set -e ; \
	  [ -d ebin ] || mkdir ebin ; \
	  for d in $(SUBDIRS) ; do \
	    if [ -f $$d/Makefile ]; then ( cd $$d && $(MAKE) $@ ) || exit 1 ; fi ; \
	  done


touch:
	find . -name '*' -print | xargs touch -m
	find . -name '*.erl' -print | xargs touch -m

=== applications/mail/Makefile ===
SUBDIRS	= src
include ./include.mk


all debug clean install:
	@set -e ; \
	  for d in $(SUBDIRS) ; do \
	    if [ -f $$d/Makefile ]; then ( cd $$d && $(MAKE) $@ ) || exit 1 ; fi ; \
	  done


touch:
	find . -name '*' -print | xargs touch -m
	find . -name '*.erl' -print | xargs touch -m

=== applications/yapp/Makefile ===
YAWSDIRECTORY=../..
include vsn.mk
include $(YAWSDIRECTORY)/include.mk

VSN = $(YAPP_VSN)
APPNAME=yapp
DOC_OPTS=[{def,{vsn,"$(VSN)"}}]
INSTALL=$(YAWSDIRECTORY)/install-sh


all:
	(cd src;$(MAKE))

clean:
	(cd src;$(MAKE) clean)

appfile:
	(cd src;$(MAKE) ../ebin/$(APPNAME).app)

docs:
	$(ERL) -noshell  -run edoc_run application "'$(APPNAME)'" '"."' '$(DOC_OPTS)' -s init stop

cleandocs:
	rm -rf doc/*.html doc/edoc-info doc/stylesheet.css doc/*.png

install: all docs
	$(INSTALL) -d $(DESTDIR)$(LIBDIR)/$(APPNAME)/ebin
	$(INSTALL) -d $(DESTDIR)$(LIBDIR)/$(APPNAME)/priv/docroot
	$(INSTALL) -d $(DESTDIR)$(LIBDIR)/$(APPNAME)/doc
	(tar cf - ebin priv doc) | (cd $(DESTDIR)$(LIBDIR)/yapp; tar xf - )

=== debian/changelog ===
yaws (1.98-2) unstable; urgency=low

  * Use userdel --force in postrm script to remove the yaws user on purging
    the yaws package.
  * Create yaws homedir if it doesn't exist in postinst script.
  * Delete /etc/yaws directory in postrm script only if it does exist.
  * Use init functions from lsb-base to report init.d script progress and
    status.
  * More carefully process errors when starting and stopping the Yaws daemon
    (closes: #728796).

 -- Sergei Golovan <sgolovan@debian.org>  Fri, 20 Dec 2013 15:49:50 +0400

yaws (1.98-1) unstable; urgency=low

  * New upstream bugfix release.

 -- Sergei Golovan <sgolovan@debian.org>  Tue, 12 Nov 2013 09:20:34 +0400

yaws (1.97-2) unstable; urgency=low

  * Added --with autotools_dev dh option to fix build on arm64 architecture
    (closes: #727526).

 -- Sergei Golovan <sgolovan@debian.org>  Mon, 04 Nov 2013 08:37:55 +0400

yaws (1.97-1) unstable; urgency=low

  * New upstream release.
  * Removed patch which fixed building with Erlang R16B01.

 -- Sergei Golovan <sgolovan@debian.org>  Sat, 19 Oct 2013 17:37:30 +0400

yaws (1.96-4) unstable; urgency=low

  * Fixed cleaning in debian/rules (closes: #724165).

 -- Sergei Golovan <sgolovan@debian.org>  Mon, 23 Sep 2013 10:49:44 +0400

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
 Package: yaws
 Architecture: all
 Provides: httpd, httpd-cgi
-Depends: erlang-yaws (>= ${binary:Version}), adduser, ssl-cert, ${misc:Depends}
+Depends: erlang-yaws (>= ${binary:Version}), adduser, ssl-cert, lsb-base (>= 3.0-6), ${misc:Depends}
 Suggests: yaws-doc, yaws-chat, yaws-mail, yaws-wiki, yaws-yapp
 Description: High performance HTTP 1.1 webserver written in Erlang
  Yaws is a high performance HTTP 1.1 webserver written in Erlang. It is a

=== debian/rules ===
--- 
+++ 
@@ -30,9 +30,9 @@
 endif
 
 %:
-	dh $@
+	dh $@ --with autotools_dev
 
-override_dh_clean:
+override_dh_auto_clean:
 	dh_testdir
 	dh_testroot
 	#
@@ -52,8 +52,6 @@
 	#
 	rm -f erl_crash.dump
 	rm -f debian/yaws-*.postinst debian/yaws-*.postrm
-	#
-	dh_clean
 
 override_dh_auto_configure:
 	dh_testdir
@@ -160,7 +158,7 @@
 	erlang-depends
 	dh_gencontrol
 
-v=1.96
+v=1.98
 
 get-orig-source:
 	wget -O - http://yaws.hyber.org/download/yaws-$(v).tar.gz | tar zx
@@ -168,6 +166,7 @@
 	rm -r yaws-$(v)
 	rm yaws
 
-.PHONY: override_dh_clean override_dh_auto_configure override_dh_auto_build-arch override_dh_auto_build-indep \
-	override_dh_auto_test override_dh_auto_install-arch override_dh_auto_install-indep \
-	override_dh_compress override_dh_gencontrol get-orig-source
+.PHONY: override_dh_auto_clean override_dh_auto_configure override_dh_auto_build-arch \
+	override_dh_auto_build-indep override_dh_auto_test override_dh_auto_install-arch \
+	override_dh_auto_install-indep override_dh_compress override_dh_gencontrol \
+	get-orig-source
